﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Diplo.Configs
{
    /// <summary>
    /// Staticka treda, ktora obsahuje VSETKY konfiguracne parametre
    /// (pre vykreslovanie a mentalne mapy)
    /// </summary>
    class Config
    {
        /* *******************************************
         * *** Spolocne nastavenia
         * *******************************************
         */
        
        // Nastavenia pre graf
        static public int vertexArea = 10; 
        static public Boolean drawVertexBoundary = false; // kreslenie ramca, cez ktory nemoze viest cesta
        static public int fieldSize = 1000;

        
        // spolocne nastavemia pre kreslenie grafu
        static public Boolean drawAlgoPath = false; // cesta, ktoru navrhuje kresliaci algoritmus
        static public Boolean drawOldPath = false; // cesta, ktora bola vykreslena pred zmenou
        static public Boolean drawDiffPolygon = false;


        /* *******************************************
         * *** Merania
         * *******************************************
         */

        // (1) mentalna mapa - MaxDif
        static public int maxDifferent = 2;
        
        // ----------------------------------------
        
        // (2) mentalna mapa - Coridor
        static public int coridorExtenderType = 0; // CoridorExtender
        static public int coridorCreateType = 0; // CoridorMap
        static public Boolean showPoligon = true; // kreslenie koridoru
        static public Boolean extendCoridor = true; // nafukovat koridor ?
        static public Double alpha = 250; // alfa polomer
        static public Double alphaReal = 250; // real alfa polomer
        static public int movementArea = 40;

        // interne nastavenia pre koridor
        static public Boolean drawBasicCorridors = false;
        static public Boolean drawExtendedCorridors = false;


        /* ********************************
         * *** Merania
         * ********************************
         */

        // Measurements - Heuristic - Binary
        static public int maxDepth = 5;
        static public Boolean showMiddlePoints = false;

        // Measurements - PathLenghtComparer
        static public double PathLengthComparerTreshold = 1.03;

        // Measurements - PathEquality
        static public int PathEqualityMaxDepth = 5;
        static public int PathEqualityTreshold = 3;


        /* ********************************
         * *** ROBOT
         * ********************************
         */

        static public int robotFrequene = 2000;
    }
}
