﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace Diplo.Debug
{
    /// <summary>
    /// Štandartná trieda pre Debug-ovacie účely. Do špeciálneho LOG súboru sa uchovávajú všetky dôležité
    /// kroky, ktoré sa počas behu aplikácie vykonávajú.
    /// </summary>
    class MyDebug
    {
        /// <summary>
        /// <para>Prefix. Tento prefix sa prikladá ku každému záznamu v log súbore.</para>
        /// </summary>
        private static String debugPrefix = "DEBUG : ";
        
        /// <summary>
        /// <para>Inštancia okna, v ktorom sa pre používateľa zobrazujú Debug-ovacie záznamy.</para>
        /// </summary>
        public static DebugWindow mDebugWindow;
       
        /// <summary>
        /// <para>Základna metóda pre debugovanie. Uloží debugovaciu správu do log súboru a zobrazia sa aj v
        /// debugovaciom okne.</para>
        /// </summary>
        /// <param name="msg">Správa pre vloženie do súboru</param>
        public static void print(String msg)
        {
            Console.WriteLine("(" + DateTime.Now.ToString("HH:mm:ss") + ") " + debugPrefix + msg);

            using (System.IO.StreamWriter file = new System.IO.StreamWriter(System.IO.Directory.GetCurrentDirectory() + @"\files\log.txt", true))
            {
                file.WriteLine("(" + DateTime.Now.ToString("HH:mm:ss") + ") " + debugPrefix + msg);
                file.Flush();
                file.Close();
            }

            mDebugWindow.listBox.Items.Add("(" + DateTime.Now.ToString("HH:mm:ss") + ") " + debugPrefix + msg);
        }

    }
}
