﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Diplo.GraphObjects;

namespace Diplo.DrawAlgorithms
{
    /// <summary>
    /// Interface, ktorý musia spĺňať všetky kresliace algoritmi
    /// </summary>
    interface DrawInterface
    {

        /// <summary>
        /// <para>Nájdenie cesty z bodu START do bodu END </para>
        /// </summary>
        /// <param name="g">Grafický komponent</param>
        /// <param name="graf">Inštancia grafu</param>
        /// <param name="start">Štart bod</param>
        /// <param name="end">Koncový bod</param>
        /// <param name="fieldSize">Veľkosť plochy pre vrchol</param>
        /// <returns>Cesta, množina bodov</returns>
        Stack<Point> draw(Graphics g, Graph graf, Point start, Point end, int fieldSize);
        
        /// <summary>
        /// <para>Nájdenie cesty z bodu START do bodu END. Pri hľadaní, cesta nemôže výjsť z poligónu (oblasti)</para>
        /// </summary>
        /// <param name="g">Grafický komponent</param>
        /// <param name="graf">Inštancia grafu</param>
        /// <param name="start">Štart bod</param>
        /// <param name="end">Koncový bod</param>
        /// <param name="Polygon">Poligon - Koridor</param>
        /// <returns>Cesta, množina bodov</returns>
        Stack<Point> drawIntoPolygon(Graphics g, Graph graf, Point start, Point end, Stack<Point> Polygon);

    }
}
