﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Diplo.GraphObjects;

namespace Diplo.DrawAlgorithms
{

    class Eades
    {

        int vertexSize = 8;

        public void simleEad(System.Windows.Forms.PaintEventArgs e, PictureBox pictureBox1)
        {

            Graphics g = e.Graphics;

            Graph graf = new Graph(35, 22);


            // vykreslime graf
            //this.drawGraph(g, graf, true, false, false);

            double c1 = 2;
            double c2 = 1;
            double c3 = 1;
            double c4 = 0.1;

            int iterCount = 120; // iterujeme algoritmus
            for (int i = 0; i < iterCount; i++)
            {
                
                // pritazliva sila
                double fov1 = 0; // force on vortex
                double fov2 = 0; // force on vortex
                int count = 0;
                foreach (Edge edge in graf.edges)
                {
                    count++;

                    Vertex v1 = (from vertex in graf.vertices where vertex.index == edge.node1Index select vertex).First();
                    Vertex v2 = (from vertex in graf.vertices where vertex.index == edge.node2Index select vertex).First();

                    double x = Math.Abs(v1.pos[0] - v2.pos[0]);
                    double y = Math.Abs(v1.pos[1] - v2.pos[1]);
                    double dis = Math.Sqrt(Math.Pow(x, 2) + Math.Pow(y, 2));

                    fov1 = c1 * Math.Log10(dis / c2); // sila, ktorou sa pritahuju

                    if (fov1 * c4 > 0)
                    {
                        if (v1.pos[0] > v2.pos[0])
                        {
                            v1.pos[0] = Math.Round(v1.pos[0] + fov1 * -1 * c4);
                            v2.pos[0] = Math.Round(v2.pos[0] + fov1 * c4);
                        }
                        else
                        {
                            v1.pos[0] = Math.Round(v1.pos[0] + fov1 * c4);
                            v2.pos[0] = Math.Round(v2.pos[0] + fov1 * -1 * c4);
                        }

                        if (v1.pos[1] > v2.pos[1])
                        {
                            v1.pos[1] = v1.pos[1] + fov1 * (-1) * c4;
                            v2.pos[1] = v2.pos[1] + fov1 * c4;
                        }
                        else
                        {
                            v1.pos[1] = v1.pos[1] + fov1 * c4;
                            v2.pos[1] = v2.pos[1] + fov1 * (-1) * c4;
                        }
                    }

                    //System.Console.WriteLine(v1.pos[0] + "|" + v1.pos[1]);
                    //System.Console.WriteLine(v2.pos[1] + "|" + v2.pos[1]);
                }

                // odpudiva sila
                count = 0;
                foreach (Vertex u in graf.vertices) // pre kazdy vrchol
                {
                    foreach (Vertex v in graf.vertices) // hladam iny vrchol (iny ak u), ktory s nim nema spojenie
                    {
                        if (u.index != v.index) // ak je to iny vrchol
                        {
                            // existuje hrana ?
                            bool check = false;
                            foreach (Edge edge in graf.edges)
                            {
                                Vertex v1 = (from vertex in graf.vertices where vertex.index == edge.node1Index select vertex).First();
                                Vertex v2 = (from vertex in graf.vertices where vertex.index == edge.node2Index select vertex).First();
                                if ((v1.index == u.index && v2.index == v.index) || (v1.index == u.index && v2.index == v.index)) { check = true; }
                            }

                            if (!check)
                            {
                                count++;

                                double x = Math.Abs(u.pos[0] - v.pos[0]);
                                double y = Math.Abs(u.pos[1] - v.pos[1]);
                                double dis = Math.Sqrt(Math.Pow(x, 2) + Math.Pow(y, 2));

                                fov2 = c3 / Math.Sqrt(dis);

                                //g.DrawString(fov2.ToString(), new Font("Arial", 10), System.Drawing.Brushes.Blue, new Point(450, 15 * count));

                                if (u.pos[0] > v.pos[0])
                                {
                                    u.pos[0] = u.pos[0] + fov2 * c4;
                                    v.pos[0] = v.pos[0] + fov2 * (-1) * c4;
                                }
                                else
                                {
                                    u.pos[0] = u.pos[0] + fov2 * (-1) * c4;
                                    v.pos[0] = v.pos[0] + fov2 * c4;
                                }


                                if (u.pos[1] > v.pos[1])
                                {
                                    u.pos[1] = u.pos[1] + fov2 * c4;
                                    v.pos[1] = v.pos[1] + fov2 * (-1) * c4;
                                }
                                else
                                {
                                    u.pos[1] = u.pos[1] + fov2 * (-1) * c4;
                                    v.pos[1] = v.pos[1] + fov2 * c4;
                                }

                            }

                        }
                    }

                }


                if (i % 10 == 0)
                {
                    //this.drawGraph(g, graf, true, false, false);
                }

                

            }

            this.drawGraph(g, graf, false, true, true);

        }




        private void drawGraph(Graphics g, Graph graph, bool drawCirle = true, bool drawFillCirle = true, bool drawLines = true)
        {

            if (drawCirle || drawFillCirle)
            {
                foreach (Vertex v in graph.vertices)
                {
                    int x = (int)Math.Round(v.pos[0]);
                    int y = (int)Math.Round(v.pos[1]);

                    SolidBrush blackBrush = new SolidBrush(Color.Black);

                    // elipsa - vrchol
                    if (drawCirle) { g.DrawEllipse(System.Drawing.Pens.Black, x, y, vertexSize, vertexSize); }
                    if (drawFillCirle) { g.FillEllipse(blackBrush, x, y, vertexSize, vertexSize); }
                }
            }

            if (drawLines)
            {
                foreach (Edge edge in graph.edges)
                {
                    Vertex v1 = (from vertex in graph.vertices where vertex.index == edge.node1Index select vertex).First();
                    Vertex v2 = (from vertex in graph.vertices where vertex.index == edge.node2Index select vertex).First();

                    int x1 = (int)Math.Round(v1.pos[0]);
                    int y1 = (int)Math.Round(v1.pos[1]);

                    int x2 = (int)Math.Round(v2.pos[0]);
                    int y2 = (int)Math.Round(v2.pos[1]);

                    SolidBrush blackBrush = new SolidBrush(Color.Black);

                    g.DrawLine(System.Drawing.Pens.Black, x1 + vertexSize/2, y1 + vertexSize/2, x2 + vertexSize/2, y2 + vertexSize/2);

                }                   
            }

        }
        

    }
}
