﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Diplo.Libs.Drawing;
using System.Drawing.Drawing2D;
using Diplo.Robot;
using Diplo.Robot.Operations;
using Diplo.MentalMap;
using System.IO;
using Diplo.Debug;
using Diplo.UI.Visual;
using Diplo.GraphObjects;
using Diplo.Configs;

namespace Diplo
{
    public partial class Form1 : Form
    {
        // trieda pre Drag and Drop mysou
        HighLighter mHighLighter = new HighLighter();
        // drag and drop
        Vertex mDragedVertex = new Vertex();
        private Boolean mouseIsDown = false;
        private int shiftX = 0;
        private int shiftY = 0;
        private Vertex mItemDraged = null;

        // riadiace objekty
        MainDraw MainDraw = new MainDraw();
        MaxDifMap MaxDiffController;
        CoridorMap CoridorController;

        // mazanie
        Boolean deleting = false;
        // pridavanie
        Boolean adding = false;
        // pridavanie
        Boolean addingEdge = false;
        Vertex firstEdgeVertex = null;

        DebugWindow mDebugWindow = null;

        public Boolean needToRedraw = true;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            pictureBox1.Width = this.Width;
            pictureBox1.Height = this.Height;

            // natsavime pozadie na biele
            pictureBox1.Dock = DockStyle.Fill;
            pictureBox1.BackColor = Color.White;

            // Connect the Paint event of the PictureBox to the event handler method.
            pictureBox1.Paint += new System.Windows.Forms.PaintEventHandler(this.pictureBox1_Paint);

            // Add the PictureBox control to the Form.
            this.Controls.Add(pictureBox1);

            this.listBox1.SelectedIndex = 0;
            this.listBox2.SelectedIndex = 0;
            this.listBox3.SelectedIndex = 0;
            this.listBox4.SelectedIndex = 0;
            this.listBox5.SelectedIndex = 0;

            this.MaxDiffController = this.MainDraw.LeeMMMaxDif;
            this.CoridorController = this.MainDraw.coridor;

            textBox1.Text = Config.maxDifferent.ToString();
            textBox3.Text = Config.alpha.ToString();
            textBox4.Text = Config.alphaReal.ToString();
            textBox2.Text = Config.movementArea.ToString();


            initTooltips();

            mDebugWindow = new DebugWindow();
            MyDebug.mDebugWindow = this.mDebugWindow;
            File.Delete(System.IO.Directory.GetCurrentDirectory() + @"\files\log.txt");
            MyDebug.print("Štart aplikácie");
            
        }

        private void pictureBox1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            g.SmoothingMode = SmoothingMode.AntiAlias;

            if (!this.mouseIsDown)
            {
                // graficky komponent...
                DateTime startTime = DateTime.Now;
                StartTime.Text = startTime.ToString("HH:mm:ss.ffffff");

                // dosle k zmene ???

                MainDraw.draw(e, pictureBox1, this.needToRedraw);
                this.needToRedraw = false;

                DateTime endTime = DateTime.Now;
                EndTime.Text = endTime.ToString("HH:mm:ss.ffffff");
                TimeSpan elapsedTime = endTime - startTime;
                DiffTime.Text = elapsedTime.ToString();

                textBox4.Text = Config.alphaReal.ToString();
            }
            else
            {
                DrawBackground.hex(g, pictureBox1);
                MainDraw.drawGraphInCache(g);

                g.FillEllipse(new SolidBrush(Color.Green), Convert.ToInt32(Math.Round(this.mDragedVertex.pos[0])),
                    Convert.ToInt32(Math.Round(this.mDragedVertex.pos[1])), this.mDragedVertex.size, this.mDragedVertex.size);
            }


            this.updateMeasurements();
        }


        /// <summary>
        /// Aktivacia Robota
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void RobotLaunch_Click_1(object sender, EventArgs e)
        {
            // pripravit Visual.UI - disable tabov a tlacitiek na prvom TAB1 (do inych sa nemoze dostat)
            tabControl4.Enabled = false;
            info.Text = "... Štart ...";

            // Nastavit operacie podla scenara
            OperationManager mOperationManager = new OperationManager(this.MainDraw.graf, this, info);
            if (listBox5.SelectedIndex == 0)
            {
                mOperationManager.operations.Add(new Wait(this));
                mOperationManager.operations.Add(new Move(10, 530, 50));
                mOperationManager.operations.Add(new Move(2, 350, 50));
                mOperationManager.operations.Add(new Move(4, 410, 160));
                mOperationManager.operations.Add(new Wait(this));
                mOperationManager.operations.Add(new Move(4, 365, 85));
                mOperationManager.operations.Add(new Move(21, 400, 130));
                mOperationManager.operations.Add(new Wait(this));
                mOperationManager.operations.Add(new Move(4, 400, 200));
                mOperationManager.operations.Add(new Move(4, 368, 84));
                mOperationManager.operations.Add(new Wait(this));

                mOperationManager.operations.Add(new Move(1, 148, 253));
                mOperationManager.operations.Add(new Wait(this));
                
                mOperationManager.operations.Add(new Move(0, 77, 106));
                mOperationManager.operations.Add(new Move(2, 350, 250));
                mOperationManager.operations.Add(new Wait(this));
                mOperationManager.operations.Add(new Move(0, 21, 205));
                mOperationManager.operations.Add(new Wait(this));
                mOperationManager.operations.Add(new Move(2, 359, 47));
                
                mOperationManager.operations.Add(new Move(5, 200, 205));
                mOperationManager.operations.Add(new Move(4, 200, 385));
                mOperationManager.operations.Add(new Wait(this));
                mOperationManager.operations.Add(new Move(4, 196, 66));

                mOperationManager.operations.Add(new Wait(this));
                mOperationManager.operations.Add(new Move(1, 385, 89));
                mOperationManager.operations.Add(new Move(3, 396, 256));

                mOperationManager.operations.Add(new Move(10, 291, 71));
                mOperationManager.operations.Add(new Wait(this));
                mOperationManager.operations.Add(new Move(4, 327, 288));
                mOperationManager.operations.Add(new Wait(this));
            }
            
            // pustenie robota
            if (mOperationManager.operations.Count > 0)
            {
                mOperationManager.performAll();
            }

            // obnova Visual.UI - pre pracu
            tabControl4.Enabled = true;
            info.Text = "";
        }

        private void button13_Click(object sender, EventArgs e)
        {
            if (button13.Text == "Debug")
            {
                mDebugWindow.Show();
                button13.Text = "Zatvorit Debug";
            }
            else
            {
                mDebugWindow.Hide();
                button13.Text = "Debug";
            }
            
        }

        private void statsReset_Click(object sender, EventArgs e)
        {
            MeasurementBin.MeasurementBinAlgoCountValue = 0;
            MeasurementBin.MeasurementBinAlgoTogetherValue = 0;
            MeasurementBin.MeasurementBinAlgoAverageValue = 0;
            MeasurementBin.MeasurementBinAlgoLastValue = 0;

            MeasurementBin.MeasurementBinCountValue = 0;
            MeasurementBin.MeasurementBinTogetherValue = 0;
            MeasurementBin.MeasurementBinAverageValue = 0;
            MeasurementBin.MeasurementBinLastValue = 0;

            MeasurementBin.LengthProportionAlgoCountValue = 0;
            MeasurementBin.LengthProportionAlgoTogetherValue = 0;
            MeasurementBin.LengthProportionAlgoLastValue = 0;
            MeasurementBin.LengthProportionCountValue = 0;
            MeasurementBin.LengthProportionMMTogetherValue = 0;
            MeasurementBin.LengthProportionMMLastValue = 0;

            MeasurementBin.PathEqualityAlgoCountValue = 0;
            MeasurementBin.PathEqualityAlgoTogetherValue = 0;
            MeasurementBin.PathEqualityAlgoLastValue = 0;
            MeasurementBin.PathEqualityMMCountValue = 0;
            MeasurementBin.PathEqualityMMTogetherValue = 0;
            MeasurementBin.PathEqualityMMLastValue = 0;

            MeasurementBin.MeasurementBinAlgoAll = new List<double>();
            MeasurementBin.MeasurementBinMMAll = new List<double>();
            MeasurementBin.LengthProportionMMAll = new List<double>();
            MeasurementBin.LengthProportionAlgoAll = new List<double>();
            MeasurementBin.PathEqualityMMAll = new List<double>();
            MeasurementBin.PathEqualityAlgoAll = new List<double>();

            this.updateMeasurements();
        }

        

        // TODO : zobrazenie Debug okienka ...
    }
}
