﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Diplo.UI.Visual;
using System.IO;
using Diplo.Debug;
using Diplo.UI.MentalMapModifiers;
using Diplo.Configs;

namespace Diplo
{
    public partial class Form1 : Form
    {


        /// <summary>
        /// Button pre zapínanie / vypínanie kreslenia oblastí vrchola
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button14_Click(object sender, EventArgs e)
        {
            if (this.button14.Text == "Zapnúť")
            {
                Config.drawVertexBoundary = true;
                this.button14.Text = "Vypnúť";
            }
            else
            {
                Config.drawVertexBoundary = false;
                this.button14.Text = "Zapnúť";
            }
        }

        /// <summary>
        /// Button pre ziadnu reakciu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            MyDebug.print("***");
            MyDebug.print("Žiadna interakcia s grafom");
            this.needToRedraw = true;
            pictureBox1.Invalidate();

        }

        /// <summary>
        /// Reset grafu do spustacej podoby. Mentalne mapy su premazane, vrcholy a hrany su obnovene.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            MainDraw.resetGrapf();
            pictureBox1.Invalidate();
        }

        /// <summary>
        /// Zmena Mentalnej mapy
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.MainDraw.mentalMapType = this.listBox1.SelectedIndex;
        }

        /// <summary>
        /// Zmena kresliaceho algoritmu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void listBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.MainDraw.algoType = this.listBox2.SelectedIndex;
        }

        // ********************************************************************************
        // *** Ovladanie pre MaxDiff

        /// <summary>
        /// Button pre zapinanie vykreslovania rozdieloveho polygonu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button4_Click(object sender, EventArgs e)
        {
            DiffController.drawDiffPolygon(this.MaxDiffController, button4);
        }

        /// <summary>
        /// Button pre zapinanie vykreslovania povodnej cesty
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button5_Click(object sender, EventArgs e)
        {
            DiffController.drawOriginalPath(this.MaxDiffController, button5);
        }

        /// <summary>
        /// Button pre zapinanie vykreslovanai starej cesty
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button6_Click(object sender, EventArgs e)
        {
            DiffController.drawOldPath(this.MaxDiffController, button6);
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            DiffController.changeDiffCount(this.MaxDiffController, textBox1);
        }

        // ********************************************************************************
        // *** Ovladanie pre Koridor

        /// <summary>
        /// TextBox pre zmenu pociatovej hodnoty alfa hran
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox3_TextChanged(object sender, EventArgs e)
        {
            CoridorMapController.alphaChange(this.CoridorController, textBox3);
        }

        /// <summary>
        /// TextBox pre zmenu movement area
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            CoridorMapController.movementAreaChange(this.CoridorController, textBox2);
        }

        /// <summary>
        /// Button pre zapinanie / vypinanie rozsirovania kodidorov
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button7_Click(object sender, EventArgs e)
        {
            CoridorMapController.extendCoridor(this.CoridorController, button7);
        }

        /// <summary>
        /// Button pre zapinanie / vypinanie kreslenia alfa kruznic
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button9_Click(object sender, EventArgs e)
        {
            CoridorMapController.alphaCircles(this.CoridorController, button9);
        }

        /// <summary>
        /// Button pre zapinanie / vypinanie kreslenia triangulacnych ciar
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button8_Click(object sender, EventArgs e)
        {
            CoridorMapController.triangulation(this.CoridorController, button8);
        }

        private void listBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            Config.coridorCreateType = this.listBox3.SelectedIndex;
        }

        private void listBox4_SelectedIndexChanged(object sender, EventArgs e)
        {
            Config.coridorExtenderType = this.listBox4.SelectedIndex;
        }


        /// <summary>
        /// Mazanie vrcholov
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button3_Click(object sender, EventArgs e)
        {
            if (this.deleting)
            {
                info.Text = "";
                this.deleting = false;
            }
            else
            {
                info.Text = "Pozor - kliknutím zmažete vrcholy";
                this.deleting = true;
                this.adding = false;
                this.addingEdge = false;
                this.firstEdgeVertex = null;
            }
        }

        /// <summary>
        /// Pridavanie vrcholov
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button10_Click(object sender, EventArgs e)
        {
            if (this.adding)
            {
                info.Text = "";
                this.adding = false;
            }
            else
            {
                info.Text = "Pozor - kliknutím pridáťe nový vrchol";
                this.adding = true;
                this.deleting = false;
                this.addingEdge = false;
                this.firstEdgeVertex = null;
            }
        }

        /// <summary>
        /// Vytvaranie hran
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button11_Click(object sender, EventArgs e)
        {
            if (this.addingEdge)
            {
                info.Text = "";
                this.addingEdge = false;
            }
            else
            {
                info.Text = "Pozor - označením dvoch vrcholov sa vytvorí hrana";
                this.addingEdge = true;
                this.firstEdgeVertex = null;
                this.deleting = false;
                this.adding = false;
            }
        }

        /// <summary>
        /// Export nameranych udajov do txt suborov
        /// le1.txt - PathEquality s mentalnou mapou <br />
        /// le2.txt - PathEquality algo cestou <br />
        /// bm1.txt - Priemerna vzdialenost s mentanou mapu (bm1log-zlogaritmovane data) <br />
        /// bm2.txt - Priemerna vzdialenost s algo cestou (bm2log-zlogaritmovane data) <br />
        /// lp1.txt - LengthProprotion s mentalnou mapou <br />
        /// lp2.txt - LengthProprotion s algou cestou <br />
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button12_Click_1(object sender, EventArgs e)
        {
            // data z PathEquality - percenta, ako su si cesty podobne
            File.Delete(System.IO.Directory.GetCurrentDirectory() + @"\files\1.txt");
            using (System.IO.StreamWriter file = new System.IO.StreamWriter(System.IO.Directory.GetCurrentDirectory() + @"\files\1.txt", true))
            {
                int i = 0;
                foreach (Double num in MeasurementBin.PathEqualityMMAll)
                {
                    i++;
                    String s = "    " + i + "   " + num.ToString();
                    file.WriteLine(s);
                }
            }

            File.Delete(System.IO.Directory.GetCurrentDirectory() + @"\files\2.txt");
            using (System.IO.StreamWriter file = new System.IO.StreamWriter(System.IO.Directory.GetCurrentDirectory() + @"\files\2.txt", true))
            {
                int i = 0;
                foreach (Double num in MeasurementBin.PathEqualityAlgoAll)
                {
                    i++;

                    Console.WriteLine(num);

                    String s = "    " + i + "   " + num.ToString();
                    file.WriteLine(s);
                }
            }

            // Binary Measurement - priemerna vzdialenost
            File.Delete(System.IO.Directory.GetCurrentDirectory() + @"\files\3.txt");
            using (System.IO.StreamWriter file = new System.IO.StreamWriter(System.IO.Directory.GetCurrentDirectory() + @"\files\3.txt", true))
            {
                int i = 0;
                foreach (Double num in MeasurementBin.MeasurementBinMMAll)
                {
                    i++;
                    String s = "    " + i + "   " + num.ToString();
                    file.WriteLine(s);
                }
            }
            File.Delete(System.IO.Directory.GetCurrentDirectory() + @"\files\3log.txt");
            using (System.IO.StreamWriter file = new System.IO.StreamWriter(System.IO.Directory.GetCurrentDirectory() + @"\files\3log.txt", true))
            {
                int i = 0;
                foreach (Double num in MeasurementBin.MeasurementBinMMAll)
                {
                    i++;
                    String s = "    " + i + "   " + Math.Log(num).ToString();
                    file.WriteLine(s);
                }
            }

            File.Delete(System.IO.Directory.GetCurrentDirectory() + @"\files\4.txt");
            using (System.IO.StreamWriter file = new System.IO.StreamWriter(System.IO.Directory.GetCurrentDirectory() + @"\files\4.txt", true))
            {
                int i = 0;
                foreach (Double num in MeasurementBin.MeasurementBinAlgoAll)
                {
                    i++;
                    String s = "    " + i + "   " + num.ToString();
                    file.WriteLine(s);
                }
            }

            File.Delete(System.IO.Directory.GetCurrentDirectory() + @"\files\4log.txt");
            using (System.IO.StreamWriter file = new System.IO.StreamWriter(System.IO.Directory.GetCurrentDirectory() + @"\files\4log.txt", true))
            {
                int i = 0;
                foreach (Double num in MeasurementBin.MeasurementBinAlgoAll)
                {
                    i++;
                    String s = "    " + i + "   " + Math.Log(num).ToString();
                    file.WriteLine(s);
                }
            }

            // Length Proportion - pomer medzi najlepsiu a skutcnou vzdialenostou 
            File.Delete(System.IO.Directory.GetCurrentDirectory() + @"\files\5.txt");
            using (System.IO.StreamWriter file = new System.IO.StreamWriter(System.IO.Directory.GetCurrentDirectory() + @"\files\5.txt", true))
            {
                int i = 0;
                foreach (Double num in MeasurementBin.LengthProportionMMAll)
                {
                    i++;
                    String s = "    " + i + "   " + num.ToString();
                    file.WriteLine(s);
                }
            }

            File.Delete(System.IO.Directory.GetCurrentDirectory() + @"\files\6.txt");
            using (System.IO.StreamWriter file = new System.IO.StreamWriter(System.IO.Directory.GetCurrentDirectory() + @"\files\6.txt", true))
            {
                int i = 0;
                foreach (Double num in MeasurementBin.LengthProportionAlgoAll)
                {
                    i++;
                    String s = "    " + i + "   " + num.ToString();
                    file.WriteLine(s);
                }
            }
        }

    }
}
