﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Security.Cryptography;
using Diplo.UI.Visual;
using Diplo.GraphObjects;

namespace Diplo
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// Click mysou
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {

            List<Vertex> mItemList = this.mHighLighter.isInObject(this.MainDraw.graf, e.X, e.Y);
            if (mItemList.Count > 0)
            {
                Vertex mVertex = mItemList.First();

                mDragedVertex = new Vertex();

                mDragedVertex.pos[0] = mVertex.pos[0];
                mDragedVertex.pos[1] = mVertex.pos[1];
                mDragedVertex.size = mVertex.size;

                this.shiftX = e.X - Convert.ToInt32(Math.Round(mVertex.pos[0]));
                this.shiftY = e.Y - Convert.ToInt32(Math.Round(mVertex.pos[1]));
                this.mouseIsDown = true;

                this.mItemDraged = mVertex;
            }
        }

        /// <summary>
        /// Pustenie kliku mysou
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {

            if (mDragedVertex.pos[0] != 0 && mDragedVertex.pos[1] != 0)
            {
                this.mouseIsDown = false;

                this.mItemDraged.pos[0] = mDragedVertex.pos[0];
                this.mItemDraged.pos[1] = mDragedVertex.pos[1];

                mDragedVertex.pos[0] = 0;
                mDragedVertex.pos[1] = 0;
                mDragedVertex.size = 0;

                Refresh();
            }
        }


        /// <summary>
        /// Pohyb mysou
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            // hightlight
            List<Vertex> isUnderMouser = this.mHighLighter.isInObject(this.MainDraw.graf, e.X, e.Y);
            Graphics g = pictureBox1.CreateGraphics();
            this.mHighLighter.highlight(g, this.MainDraw.graf, isUnderMouser);

            if (this.mouseIsDown)
            {
                if (this.shiftX > 0)
                {
                    mDragedVertex.pos[0] = e.X - this.shiftX;
                }
                else
                {
                    mDragedVertex.pos[0] = e.X;
                }


                if (this.shiftY > 0)
                {
                    mDragedVertex.pos[1] = e.Y - this.shiftY;
                }
                else
                {
                    mDragedVertex.pos[1] = e.Y;
                }

                Refresh();
                this.needToRedraw = true;
            }
            else
            {
                if (isUnderMouser.Count > 0)
                {
                    Vertex v = isUnderMouser.ElementAt(0);

                    List<String> tips = new List<String>();
                    tips.Add("Pozícia vrchola " + v.pos[0] + "|" + v.pos[1]);
                    tips.Add("Vrchol číslo : " + v.index);

                    if (!ImageToolTip.render(g, tips, e.X, e.Y))
                    {
                        //Refresh();
                    }


                }
                else
                {
                    ImageToolTip.lasHash = "";
                    Refresh();
                }
            }

        }

        private void pictureBox1_MouseClick(object sender, MouseEventArgs e)
        {
            // mazanie
            if (this.deleting)
            {
                List<Vertex> mItemList = this.mHighLighter.isInObject(this.MainDraw.graf, e.X, e.Y);
                if (mItemList.Count > 0)
                {
                    Vertex mVertex = mItemList.First();

                    int toRemove = -1;
                    int i = 0;
                    foreach (Vertex v in MainDraw.graf.vertices)
                    {
                        if (v.pos[0] == mVertex.pos[0] && v.pos[1] == mVertex.pos[1])
                        {
                            toRemove = i;
                        }
                        i++;
                    }

                    if (toRemove != -1)
                    {
                        // zmazat vsetky incidentne hrany
                        List<int> toRemoveEdges = new List<int>();
                        i = 0;
                        foreach (Edge edge in MainDraw.graf.edges)
                        {
                            Vertex v1 = MainDraw.graf.getVerticeByIndex(edge.node1Index);
                            Vertex v2 = MainDraw.graf.getVerticeByIndex(edge.node2Index);
                            if (v1 != null & v2 != null)
                            {
                                if ((v1.pos[0] == mVertex.pos[0] && v1.pos[1] == mVertex.pos[1]) || (v2.pos[0] == mVertex.pos[0] && v2.pos[1] == mVertex.pos[1]))
                                {
                                    toRemoveEdges.Add(i);
                                }
                            }

                            i++;
                        }

                        foreach (int edgeIndex in toRemoveEdges)
                        {
                            MainDraw.graf.edges.RemoveAt(edgeIndex);
                        }



                        MainDraw.graf.vertices.RemoveAt(toRemove);
                        this.needToRedraw = true;
                    }



                }
            }


            if (this.adding)
            {
                int maxIndex = 0;
                foreach (Vertex v in MainDraw.graf.vertices)
                {
                    if (v.index > maxIndex)
                    {
                        maxIndex = v.index;
                    }
                }

                Vertex newVertex = new Vertex(maxIndex + 1, e.X - 10, e.Y - 10, 20);
                MainDraw.graf.addVertex(newVertex);
                this.needToRedraw = true;
            }

            if (this.addingEdge)
            {
                List<Vertex> mItemList = this.mHighLighter.isInObject(this.MainDraw.graf, e.X, e.Y);
                if (mItemList.Count > 0)
                {
                    Vertex mVertex = mItemList.First();
                    if (this.firstEdgeVertex == null)
                    {
                        this.firstEdgeVertex = mVertex;
                    }
                    else
                    {// uz mam oba potrebne vrcholy, vytvorim cestu
                        MainDraw.graf.addEdge(this.firstEdgeVertex.index, mVertex.index);
                        info.Text = "";
                        this.addingEdge = false;
                        this.firstEdgeVertex = null;
                    }
                    this.needToRedraw = true;

                }
            }
        }

    }
}
