﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Security.Cryptography;
using Diplo.UI.Visual;

namespace Diplo
{
    public partial class Form1 : Form
    {

        public void initTooltips()
        {
            Tab1ZiadnaInterakcia.SetToolTip(button1, "Stlačením sa na grafe nevykonajú žiadne zmeny (interakcia s vrcholmi/hranami a pod.)."+Environment.NewLine+"Prepočítajú sa cesty podľa aktuálnych mentálnych máp ciest, vypočítajú sa nové mentálne mapy pre cesty.");
            Tab1ResetGrafu.SetToolTip(button2, "Vráti štruktúru grafu (vrcholy, hrany) ako bola pri spustení aplikácie.");
            Tab1ZmazatVrchol.SetToolTip(button3, "Stlačením sa zapne možnosť mazania vrcholov v grafe." + Environment.NewLine + "Po aktivovaní, sa kliknutím (na vrchol) zmaže vrchol z grafu, spolu aj s všetkými s ním incidentnými hranami."+Environment.NewLine+"Mazanie vrcholov sa vyplne ďalším kliknutím na toto tlačítko.");
            Tab1PridatVrcholv.SetToolTip(button10, "Stlačením sa zapne možnosť pridávať vrcholy do grafu." + Environment.NewLine + "Keď sa aktivuje táto funkcia, kliknutím (kdekoľvek) na pracovnú plochu sa na danom mieste vytvorí nový vrchol" + Environment.NewLine + "Pridávanie vrcholov sa vyplne ďalším kliknutím na toto tlačítko.");
            Tab1PridatHranu.SetToolTip(button11, "Stlacením sa zapne pridávanie hrán medzi vrcholmi v grafe."+ Environment.NewLine + "Po zapnutí sa môžu vybrať dva vrcholy, medzi ktorými sa vytvorí hrana. Po pridaní hrany sa táto funkcia automaticky vypne."+Environment.NewLine+"Ak sa na toto tlačíko klikne počas výberu vrcholv pre novú hranu, funkcia sa vypne.");
            Tab1PouzitaMentalnaMapa.SetToolTip(listBox1, "V tejto roletke sa vyberá, ktorá mentálna mapa sa má použiť." + Environment.NewLine + "(Zmena sa udeje až po nasledujúcej interakcií / či stlačení tlačítka 'Žiadna interakcia s grafom')");
        
            // TAB 2 - Vseobecne Nastavenia
            Tab2Oblast.SetToolTip(button4, "Zapnutie / Vypnutie zvýrazňovania oblasti, ktorá vznikne medzi cestou," + Environment.NewLine + "ktorú navrhuje kresliaci algoritmus a cestou, ktorá vznikne pri použití niektorej z mentálnej mapy." + Environment.NewLine + "Kreslenie tejto oblasti sa aplikuje len pri zapnutej mentálnej mape(ľubovoľná).");
            Tab2StaraCesta.SetToolTip(button6, "Týmto nastavením sa aktivuje kreslenie 'starých ciest'." + Environment.NewLine + "Stará cesta pre danú cestu je tá, ktorá bola vykreslená pred interakciou s grafom." + Environment.NewLine + "Táto stará cesta môže byť totožná s súčastnou cestou (ak nedošlo k žiadnej zmene pri vykreslení cesty), alebo rozdielná od súčastnej cesty (cesta sa zmenila)." + Environment.NewLine + "Táto cesta sa môže použiť pre posúdenie, ako veľmi sa cesta pri interakcií zmenila" + Environment.NewLine + " - vieme opticky posúdiť zmeny medzi navrhovanou cestou (prípadne výslednou cestou) a cestou, ktorá bola vykreslená pred interakciou.");
            Tab2AlgoCesta.SetToolTip(button5, "Kreslenie (zapnutie/vypnutie) cesty, ktorú navrhuje kresliaci algoritmus." + Environment.NewLine + "Ak sa používa mentálna mapa, je to cesta, ktorá by vznikla (a bola by použitá) bez aplikovania mentálnej mapy." + Environment.NewLine + "Medzi touto cestou a výslednou (použitou cestou) vzniká oblasť, ktorá sa dá zvýrazňovať (druhé tlačítko nad týmto). " + Environment.NewLine + "Ak sa nepoužíva žiadna mentálna mapa, je táto cesta totožná s výslednou cestou - kreslí sa vždy." + Environment.NewLine + "Medzi touto a výslednou cestou sa takysto vykonávajú mnohé merania, aby sa zistili, aký vplyv malo použitie mentálnej mapy.");

            // TAB 3 - nastavenia pre MM1
            Tab3MaxPocet.SetToolTip(textBox1, "Parameter pre model mentálnej mapy." + Environment.NewLine + "Určuje, koľko môže byť na novej výslednej ceste (po interakcií) nových bodov (vzhľadom na starú cestu - pred interakciou).");
            
            // TAB 4 - nastavenia pre MM2
            Tab4MinRadius.SetToolTip(textBox3, "Pri vytváraní alfa hrán sa používaju alfa kružnice, ktoré majú polomer : 1 / X, " + Environment.NewLine + "kde X je hodnota, ktorá sa zadáva do tohto políčka.Ak by sa (uspokojivý) koridor nepodarilo nájsť s touto hodnotu," + Environment.NewLine + "bude automaticky zvýšená - kým sa nenájde koridor (pri najhoršom sa vypočíta konvexný obal)." + Environment.NewLine + "" + Environment.NewLine + "Štandartná hodnota - 250");
            Tab4RealRadius.SetToolTip(textBox4, "Ak hodnota alfa nebola dostatočne vysoká," + Environment.NewLine + "aby sa pomocou alfa hrán našiel uspokojivý koridor, musí sa hodnota alfa automaticky zvyšovať." + Environment.NewLine + "Tu sa ukazuje hodnota, ktorá bola použitá.");
            Tab4RealRadius.SetToolTip(textBox2, "Podkoridory (z ktorých sa zostavuje koridor) majú počiatočnú šírku - tento paramater ju nastavuje." + Environment.NewLine + "" + Environment.NewLine + "Štandartná hodnota - 40.");
            Tab4Nafukovanie.SetToolTip(button7, "Zapnutie/Vypnutie aplikovania nafukovania podkorirodov (kvôly prekážkam).");
            Tab4DrawAlfaCircle.SetToolTip(button9, "Zapnutie/Vypnutie kreslenia alfa kružníc.");
            Tab4DrawTriangulation.SetToolTip(button8, "Zapnutie/Vypnutie kreslenia Deleaunay triangulácie.");
            Tab4CoridorBinder.SetToolTip(listBox3, "Výber spôsobu, ako sa bude z podkoridorov vytvárať koridor." + Environment.NewLine + "Na výber je použitie alfa hrán alebo vypočítanie obyčajného konvexného obalu.");

            PriemernaVzdialenost.SetToolTip(MeasurementBinTitle, "Priemerná vzdialenosť je hodnota, ktorá sa vypočíta z dvoch ciest : " + Environment.NewLine + "cesty pre interakciou a výslednou cestou / cestou, ktorú navrhol kresliaci algoritmus." + Environment.NewLine + "Nižšie hodnoty sú žiadané.");
            PomerMedziCestou.SetToolTip(MeasurementLengthProportion, "V tejto tabuľke sa ukazuje pomer medzi najkratšou možnou vzdialenosťou a skutočnou vzdialenosťou cesty. " + Environment.NewLine + "Nižšie hodnoty sú žiadané.");
            PercentoZachovania.SetToolTip(MeasurementLengthEquality, "Merania, určujúce koľko percent novej výslednej / algoritmom navrhovanej cesty je totožná s pôvodnou cestou pred interakciou." + Environment.NewLine + "Najlepšia hodnota je 100 - identické cesty.");
        }

    }
}
