﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace Diplo.GraphObjects
{
    /// <summary>
    /// Hlavný objekt grafu
    /// </summary>
    class Graph
    {
        public List<Vertex> vertices = new List<Vertex>();
        public List<Edge> edges = new List<Edge>();

        public Graph()
        {

        }

        public Graph(int nodesNum, int edgesNum)
        {
            Random r = new Random();

            for (int i = 1; i <= nodesNum; i++)
            {
                this.addVertex(new Vertex(i, r));
            }



            for (int i = 0; i < edgesNum; i++)
            {
                Vertex u = this.vertices.ElementAt(r.Next(1, this.vertices.Count));
                Vertex v = this.vertices.ElementAt(r.Next(1, this.vertices.Count)); 

                bool isEdgeInGraph = this.edgeExist(u, v);
                while (isEdgeInGraph)
                {
                    u = this.vertices.ElementAt(r.Next(1, this.vertices.Count));
                    v = this.vertices.ElementAt(r.Next(1, this.vertices.Count)); 
                    isEdgeInGraph = this.edgeExist(u, v);
                }

                this.edges.Add(new Edge(u.index, v.index));

            }
        }


        /*
         * Praca s vrcholmi
         */

        public void addVertex(Vertex vrchol)
        {
            this.vertices.Add(vrchol);
        }

        public Vertex getVerticeByIndex(int index)
        {
            foreach(Vertex v in this.vertices){
                if (v.index == index) { return v; }
            }
            return null;
        }

        public List<Vertex> getVertices()
        {
            return this.vertices;
        }

        public void removeVertex(int index)
        {
            this.vertices.RemoveAll((x) => x.index == index);
        }

        /*
         * Praca s hranami
         */

        public void addEdge(int index1, int index2)
        {
            this.edges.Add(new Edge(index1, index2));
        }

        public List<Edge> getEdges()
        {
            return this.edges;
        }


        private Boolean edgeExist(Vertex v, Vertex u)
        {
            if (v.index != u.index)
            {
                foreach (Edge e in this.edges)
                {
                    if ((v.index == e.node1Index && u.index == e.node2Index) || (u.index == e.node1Index && v.index == e.node2Index)) { return true; }
                }
            }
            return false;
        }

    }

    

}
