﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Diplo.MentalMap;
using Diplo.MentalMap.CoridorObjects;

namespace Diplo.Libs.Drawing
{
    /// <summary>
    /// Trieda pre kreslenie bodu
    /// </summary>
    class DrawPoint
    {

        /// <summary>
        /// <para>Metoda vykresli bod</para>
        /// </summary>
        /// <param name="g">graficky komponent</param>
        /// <param name="p">bod na vykreslenie - ! pozor objekt : System.Drawing.Point</param>
        /// <param name="clr">farba, defaultne je to Red - cervena</param>
        public static void drawPoint(Graphics g, System.Drawing.Point p, String clr = "red")
        {
            SolidBrush SB = new SolidBrush(Color.Red);
            if (clr.Equals("Blue")) { SB = new SolidBrush(Color.Blue); }
            if (clr.Equals("Green")) { SB = new SolidBrush(Color.Green); }
            if (clr.Equals("Pink")) { SB = new SolidBrush(Color.Pink); }
            if (clr.Equals("Black")) { SB = new SolidBrush(Color.Black); }

            g.FillEllipse(SB, p.X - 3, p.Y - 3, 6, 6);
        }

        /// <summary>
        /// <para>Metoda vykresli bod</para>
        /// </summary>
        /// <param name="g">graficky komponent</param>
        /// <param name="p">bod na vykreslenie - ! pozor objekt : CoridorPoint</param>
        /// <param name="clr">farba, defaultne je to Red - cervena</param>
        public static void drawPoint(Graphics g, CoridorPoint p, String clr = "red")
        {
            SolidBrush SB = new SolidBrush(Color.Red);
            if (clr.Equals("Blue")) { SB = new SolidBrush(Color.Blue); }
            if (clr.Equals("Green")) { SB = new SolidBrush(Color.Green); }
            if (clr.Equals("Pink")) { SB = new SolidBrush(Color.Pink); }
            if (clr.Equals("Black")) { SB = new SolidBrush(Color.Black); }

            g.FillEllipse(SB, p.X - 3, p.Y - 3, 6, 6);
        }

        /// <summary>
        /// <para>Vykreslenie väčšieho bodu</para>
        /// </summary>
        /// <param name="g">graficky komponent</param>
        /// <param name="p">bod na vykreslenie - ! pozor objekt : CoridorPoint</param>
        /// <param name="clr">farba, defaultne je to Red - cervena</param>
        /// <param name="size">veľkosť, defaultne je 6</param>
        public static void drawHighligthedPoint(Graphics g, System.Drawing.Point p, String clr = "red", int size = 6)
        {
            SolidBrush SB = new SolidBrush(Color.Red);
            if (clr.Equals("Blue")) { SB = new SolidBrush(Color.Blue); }
            if (clr.Equals("Green")) { SB = new SolidBrush(Color.Green); }
            if (clr.Equals("Pink")) { SB = new SolidBrush(Color.Pink); }
            if (clr.Equals("Black")) { SB = new SolidBrush(Color.Black); }
            if (clr.Equals("Gray")) { SB = new SolidBrush(Color.Gray); }

            g.FillEllipse(SB, p.X - size, p.Y - size, size*2, size*2);
        }

        /// <summary>
        /// <para>Vykreslenie väčšieho bodu</para>
        /// </summary>
        /// <param name="g">graficky komponent</param>
        /// <param name="p">bod na vykreslenie - ! pozor objekt : CoridorPoint</param>
        /// <param name="clr">farba, defaultne je to Red - cervena</param>
        /// <param name="size">veľkosť, defaultne je 6</param>
        public static void drawHighligthedPoint(Graphics g, CoridorPoint p, String clr = "red", int size = 6)
        {
            SolidBrush SB = new SolidBrush(Color.Red);
            if (clr.Equals("Blue")) { SB = new SolidBrush(Color.Blue); }
            if (clr.Equals("Green")) { SB = new SolidBrush(Color.Green); }
            if (clr.Equals("Pink")) { SB = new SolidBrush(Color.Pink); }
            if (clr.Equals("Black")) { SB = new SolidBrush(Color.Black); }

            g.FillEllipse(SB, p.X - 6, p.Y - 6, size * 2, size * 2);
        }
    }
}
