﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace Diplo.Libs.Geometry.AlphaHull.Geometry
{
    class Voronoi
    {

        static Boolean drawCenter = false;
        static Boolean drawCircle = false;

        internal static Diplo.Libs.Geometry.AlphaHull.Geometry.CircumCircle findCircumscribe(Graphics g, Diplo.Libs.Geometry.AlphaHull.Geometry.Triangle tria, List<Diplo.Libs.Geometry.AlphaHull.Geometry.Point> Vertex)
        {
            Diplo.Libs.Geometry.AlphaHull.Geometry.Point A = Vertex.ElementAt(tria.p3);
            Diplo.Libs.Geometry.AlphaHull.Geometry.Point B = Vertex.ElementAt(tria.p1);
            Diplo.Libs.Geometry.AlphaHull.Geometry.Point C = Vertex.ElementAt(tria.p2);

            // stredy stran trojuholnika
            Diplo.Libs.Geometry.AlphaHull.Geometry.Point ABcenter = new Diplo.Libs.Geometry.AlphaHull.Geometry.Point((A.X + B.X) / 2, (A.Y + B.Y) / 2);
            Diplo.Libs.Geometry.AlphaHull.Geometry.Point BCcenter = new Diplo.Libs.Geometry.AlphaHull.Geometry.Point((B.X + C.X) / 2, (B.Y + C.Y) / 2);
            Diplo.Libs.Geometry.AlphaHull.Geometry.Point CAcenter = new Diplo.Libs.Geometry.AlphaHull.Geometry.Point((C.X + A.X) / 2, (C.Y + A.Y) / 2);

            // rovnice kolmych os
            double ABm = (B.Y - A.Y) / (B.X - A.X);
            double kolmeABm = 0;
            if (ABm != 0)
            {
                kolmeABm = -1 / ABm;
            }
            double ABleftSide = ABcenter.Y;
            double ABrightSide = ABcenter.X * kolmeABm;
            double ABc = ABleftSide - ABrightSide;
            for (int i = 0; i < 15; i++ )
            {
                double x = i * 20;
                double y = i * 20 * kolmeABm + ABc;
            }

            double BCm = (C.Y - B.Y) / (C.X - B.X);
            double kolmeBCm = 0;
            if (BCm != 0)
            {
                kolmeBCm = -1 / BCm;
            }

            double BCleftSide = BCcenter.Y;
            double BCrightSide = BCcenter.X * kolmeBCm;
            double BCc = BCleftSide - BCrightSide;
            for (int i = 0; i < 15; i++)
            {
                double x = i * 20;
                double y = x * kolmeBCm + BCc; 

                if (BCm == 0) {
                    x = BCcenter.X;
                    y = i * 20;
                }
      
            }

            double CAm = (A.Y - C.Y) / (A.X - C.X);
            double kolmeCAm = 0;
            if (CAm != 0)
            {
                kolmeCAm = -1 / CAm;
            }
            double CAleftSide = CAcenter.Y;
            double CArightSide = CAcenter.X * kolmeCAm;
            double CAc = CAleftSide - CArightSide;
            for (int i = 0; i < 150; i++)
            {
                double x = i * 20;
                double y = i * 20 * kolmeCAm + CAc;
            }
            
            // najdeme dva prieniky
            double top;
            double down;
            double resX = 0;
            double resY = 0;

            
            if (BCm == 0)
            {
                resX = BCcenter.X;
                resY = kolmeABm * BCcenter.X + ABc;

            }else if(ABm == 0){
                resX = ABcenter.X;
                resY = kolmeBCm * ABcenter.X + BCc;
            }
            else
            {
                top = BCc - ABc;
                down = kolmeABm - kolmeBCm;

                if (down != 0)
                {
                    resX = top / down;
                    resY = kolmeABm * resX + ABc;
                }
                else
                {
                    resX = 0;
                    resY = kolmeABm * resX + ABc;
                }
            }

            
            if (drawCenter)
            {
                g.FillEllipse(new SolidBrush(Color.Orange), Convert.ToInt32(Math.Round(resX)) - 3,
                Convert.ToInt32(Math.Round(resY)) - 3, 6, 6);
            }


            // nakreslime kruznicu
            double d1 = Math.Abs(A.X - resX);
            double d2 = Math.Abs(A.Y - resY);

            double radius = Math.Sqrt(d1 * d1 + d2 * d2);
            if (drawCircle)
            {
                g.DrawEllipse(System.Drawing.Pens.Orange,
                    Convert.ToInt32(Math.Round(resX)) - Convert.ToInt32(Math.Round(radius)),
                    Convert.ToInt32(Math.Round(resY)) - Convert.ToInt32(Math.Round(radius)),
                    Convert.ToInt32(Math.Round(radius * 2)),
                    Convert.ToInt32(Math.Round(radius * 2)));
            }



            return new Diplo.Libs.Geometry.AlphaHull.Geometry.CircumCircle(resX, resY, radius, tria.p1, tria.p2, tria.p3);
        }


    }
}
