﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Diplo.Libs.Drawing;

namespace Diplo.Libs.Geometry
{
    /// <summary>
    /// Trieda pre rozširovanie úsečky, posúvanie a pod.
    /// </summary>
    class LineExtender
    {
        /// <summary>
        /// <para>Rozsiri usecku - danu ako dva body A / B - o vzdialenost "distance"
        /// posunie sa bod B (vrati novy, posunuty bod</para>
        /// </summary>
        /// <param name="g"></param>
        /// <param name="A"></param>
        /// <param name="B"></param>
        /// <param name="distance"></param>
        /// <returns></returns>
        public static Point extendLineSegment(Graphics g, Point A, Point B, int distance)
        {
            double alpha = (Math.Abs(Convert.ToDouble(A.Y) - Convert.ToDouble(B.Y)))
                / (Math.Abs(Convert.ToDouble(A.X) - Convert.ToDouble(B.X)));

            Point C = new Point();

            if (B.X > A.X)
            {
                C.X = Convert.ToInt32(Math.Round(B.X + distance * Math.Cos(Math.Atan(alpha))));
                if (B.Y > A.Y)
                {
                    C.Y = Convert.ToInt32(Math.Round(B.Y + distance * Math.Sin(Math.Atan(alpha))));
                }
                else
                {
                    C.Y = Convert.ToInt32(Math.Round(B.Y - distance * Math.Sin(Math.Atan(alpha))));
                }
            }
            else
            {
                C.X = Convert.ToInt32(Math.Round(B.X - distance * Math.Cos(Math.Atan(alpha))));
                if (B.Y > A.Y)
                {
                    C.Y = Convert.ToInt32(Math.Round(B.Y + distance * Math.Sin(Math.Atan(alpha))));
                }
                else
                {
                    C.Y = Convert.ToInt32(Math.Round(B.Y - distance * Math.Sin(Math.Atan(alpha))));
                }
            }
            
            return C;
        }

    }
}
