﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Diplo.Libs.Drawing;

namespace Diplo.Libs.Geometry
{
    /// <summary>
    /// TODO : pozicia bodu v poligone ... ??? asi uz niekde inde riesene
    /// </summary>
    class PointInPolygon
    {
        static public Boolean isPointInPolygon3(Graphics g, Stack<Point> poligon, Point p)
        {
            int intersectionCounter = 0;
            double[] eq1 = getLineEquation(g, p);

            // skusime, ci je dobra priamka
            int y = 0;
            while(y < 700)
            {
                int x = Convert.ToInt32(Math.Round(y / eq1[0]));
                DrawPoint.drawPoint(g, new Point(x, y), "Blue");
                y = y + 10;
            }

            for (int i = 0; i < poligon.Count - 1; i++)
            {
                Point c1 = poligon.ElementAt(i);
                Point c2 = poligon.ElementAt(i + 1);
                double[] eq2 = getLineEquation(g, c1, c2);

                // kde na y-osi sa pretinaju
                double[] yCross = twoLineIntersectionYAxe(g, eq1, eq2);

                if (Double.IsNaN(yCross[0]))
                {
                    DrawPoint.drawHighligthedPoint(g, poligon.ElementAt(i), "Pink");
                    DrawPoint.drawHighligthedPoint(g, poligon.ElementAt(i + 1), "Pink");

                    yCross[0] = c1.X;
                    yCross[1] = eq1[0] * c1.X + eq1[1];
                }

                Console.WriteLine(yCross[0] + "|" + yCross[1]);

                if (((yCross[1] >= c1.Y && yCross[1] <= c2.Y) || (yCross[1] <= c1.Y && yCross[1] >= c2.Y)) &&
                    ((yCross[0] >= c1.X && yCross[0] <= c2.X) || (yCross[0] <= c1.X && yCross[0] >= c2.X)) &&
                    (!p.Equals(new Point(Convert.ToInt32(Math.Floor(yCross[0])), Convert.ToInt32(Math.Floor(yCross[1])))))
                    )
                {
                     DrawPoint.drawHighligthedPoint(g, new Point(Convert.ToInt32(Math.Round(yCross[0])),
                        Convert.ToInt32(Math.Round(yCross[1]))), "Red");
                    intersectionCounter++;
                }

                //break;
            }

            System.Console.WriteLine("intersections : " + intersectionCounter);

            if (intersectionCounter % 2 == 0) { return false; }
            else { return true; }

        }
        
        static public Boolean isPointInPolygon2(Graphics g, Stack<Point> poligon, Point p)
        {
            int intersectionCounter = 0;
            double[] eq1 = getLineEquation(g, p);

            for (int i = 0; i < poligon.Count - 1; i++)
            {
                Point c1 = poligon.ElementAt(i);
                Point c2 = poligon.ElementAt(i + 1);
                double[] eq2 = getLineEquation(g, c1, c2);

                double[] yCross = twoLineIntersectionYAxe(g, eq1, eq2);

                // FIX - opravuje to, ked yCross nie je definovany
                // stavalo sa, ked sa jednalo o usecku, ktora bola kolma na x-ovu os
                if (Double.IsNaN(yCross[0]))
                {
                    yCross[0] = c1.X;
                    yCross[1] = eq1[0] * c1.X + eq1[1];
                }


                if (((yCross[1] >= c1.Y && yCross[1] <= c2.Y) || (yCross[1] <= c1.Y && yCross[1] >= c2.Y)) &&
                    ((yCross[0] >= c1.X && yCross[0] <= c2.X) || (yCross[0] <= c1.X && yCross[0] >= c2.X)) &&
                    (!p.Equals(new Point(Convert.ToInt32(Math.Floor(yCross[0])),  Convert.ToInt32(Math.Floor(yCross[1])))))
                    )
                {
                    intersectionCounter++;
                }
            }

            if (intersectionCounter % 2 == 0) { return false; }
            else { return true; }

        }

        static public Boolean isPointInPolygon(Graphics g, Stack<Point> poligon, Point p){
            int intersectionCounter = 0;
            double[] eq1 = getLineEquation(g, p);
            for(int i =0;i<poligon.Count-1;i++)
            {
                Point c1 = poligon.ElementAt(i);
                Point c2 = poligon.ElementAt(i + 1);

                double[] eq2 = getLineEquation(g, c1, c2);

                // kde na y-osi sa pretinaju
                double[] yCross = twoLineIntersectionYAxe(g, eq1, eq2);

                if (((yCross[1] > c1.Y && yCross[1] < c2.Y) || (yCross[1] < c1.Y && yCross[1] > c2.Y)) &&
                    ((yCross[0] > c1.X && yCross[0] < c2.X) || (yCross[0] < c1.X && yCross[0] > c2.X)) &&
                    (yCross[0] < p.X && yCross[1] < p.Y)
                    )
                {
                    intersectionCounter++;
                }

                //break;
            }

            if (intersectionCounter % 2 == 0) { return false; }
            else { return true; }

        }


        static private double[] getLineEquation(Graphics g, Point p1)
        {
            double[] equation = new double[2];
            Point p2 = new Point(0, 0);
            //DrawPoint.drawHighligthedPoint(g, p1, "Black");
            //DrawPoint.drawHighligthedPoint(g, p2, "Black");

            // vypocitame z rovnice priamky : y = ax + b prve a-cko
            double a = (Convert.ToDouble(p2.Y) - Convert.ToDouble(p1.Y)) / (Convert.ToDouble(p2.X) - Convert.ToDouble(p1.X));
            //Console.WriteLine(p2.Y + " - " + p1.Y + " / " + p2.X + " - " + p1.X);
            //Console.WriteLine("a = " + a);
            // vypocitame z rovnice priamky : y = ab + b b-cko, kedze acko uz pozname
            // vypocitame jednoduchym dosadenim x = 0, y = 0 - teda bcko mi nikdy netreba !

            equation[0] = a;
            equation[1] = 0;

            return equation;
        }

        static private double[] getLineEquation(Graphics g, Point p1, Point p2)
        {
            double[] equation = new double[2];

            double top = Convert.ToDouble(p2.Y) - Convert.ToDouble(p1.Y);
            double bottom = Convert.ToDouble(p2.X) - Convert.ToDouble(p1.X);

            double a = top / bottom;
            //Console.WriteLine(a);
            // vypocitame z rovnice priamky : y = a*x + b b-cko, kedze acko uz pozname
            // vypocitame jednoduchym dosadenim x = p1.X, y = p2.Y !
            double b = p1.Y - (a * Convert.ToDouble(p1.X));

            equation[0] = a;
            equation[1] = b;

            return equation;
        }

        static private double[] twoLineIntersectionYAxe(Graphics g, double[] eq1, double[] eq2)
        {
            double[] cross = new double[2];
            double x = (eq2[1] - eq1[1]) / (eq1[0] - eq2[0]);

            //Console.WriteLine(eq2[1] + " - " + eq1[1] + " / " + eq1[0] + " - " + eq2[0]);

            //Console.WriteLine(x);

            // skusime dopocitat bod Y
            double y = eq1[0] * x;
            //DrawPoint.drawHighligthedPoint(g, new Point(Convert.ToInt32(Math.Round(x)), Convert.ToInt32(Math.Round(y))), "Green");

            cross[0] = x;
            cross[1] = y;

            return cross;
        }

    }
}

