﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Diplo.MentalMap;
using Diplo.MentalMap.CoridorObjects;

namespace Diplo.Libs
{
    /// <summary>
    /// Trieda obsahujuca pomocne metodz pre pracu s LISTom
    /// </summary>
    class ListHelper
    {

        /// <summary>
        /// <para>Metoda zisti, ci sa bod nachadza v zozname</para>
        /// </summary>
        /// <param name="list">List - zoznam, v ktorom hladame</param>
        /// <param name="toFind">bod - ! pozor objekt : System.Drawing.Point</param>
        /// <returns></returns>
        static public Boolean isPointInList(List<Point> list, Point toFind)
        {
            foreach (Point p in list)
            {
                if (p.X == toFind.X && p.Y == toFind.Y) { return true; }
            }

            return false;
        }

        /// <summary>
        /// <para>Metoda zisti, ci sa bod nachadza v zozname - LIST</para>
        /// </summary>
        /// <param name="list">List - zoznam, v ktorom hladame</param>
        /// <param name="toFind">bod - ! pozor objekt : CoridorPoint</param>
        /// <returns></returns>
        static public Boolean isPointInList(List<CoridorPoint> list, CoridorPoint toFind)
        {
            foreach (CoridorPoint p in list)
            {
                if (p.X == toFind.X && p.Y == toFind.Y) { return true; }
            }

            return false;
        }

        /// <summary>
        /// <para>Metoda vymaze bod z zoznamu / List - vymaze sa iba taky bod, ktory ma rovnaku X a Y suradnicu</para>
        /// </summary>
        /// <param name="stack">Stack</param>
        /// <param name="toRemove">Bod na vymazanie - ! pozor objekt :  System.Drawing.Point</param>
        static public void removePointFromList(List<Point> stack, Point toRemove)
        {
            int toRemoveIndex = -1;
            for (int i = 0; i < stack.Count; i++)
            {
                if (stack.ElementAt(i).X == toRemove.X && stack.ElementAt(i).Y == toRemove.Y)
                {
                    toRemoveIndex = i;
                }
            }

            if (toRemoveIndex != -1) { stack.RemoveAt(toRemoveIndex); }
        }

    }
}
