﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace Diplo.Libs
{
    /// <summary>
    /// Trieda obsahujuca pomocne metodz pre pracu s STACKom
    /// </summary>
    class StackHelper
    {

        /// <summary>
        /// <para>Metoda zisti, ci sa bod nachadza v stacku</para>
        /// </summary>
        /// <param name="stack">List - zoznam, v ktorom hladame</param>
        /// <param name="toFind">bod - ! pozor objekt : System.Drawing.Point</param>
        /// <returns></returns>
        public static Boolean isPointInStack(Stack<Point> stack, Point toFind)
        {
            System.Console.WriteLine(toFind.X + "||" + toFind.Y);
            foreach (Point p in stack)
            {
                System.Console.WriteLine(p.X + "||" + p.Y);
                if (p.X == toFind.X && p.Y == toFind.Y) { return true; }
            }

            return false;
        }

        /// <summary>
        /// <para>Metóda zistí, či sa bod nachádza v stack-u</para>
        /// </summary>
        /// <param name="p">Bod</param>
        /// <param name="s">Stack</param>
        /// <returns></returns>
        public static Boolean isPointInStack(Point p, Stack<Point> s)
        {
            foreach (Point v in s)
            {
                if (v.X == p.X && v.Y == p.Y) { return true; }
            }
            return false;
        }

        /// <summary>
        /// <para>Prekoporivanie prvkov z jedneho stacku do druheho stacku</para> 
        /// </summary>
        /// <param name="source">Zdroj</param>
        /// <param name="dest">Kam</param>
        public static void copyStackToStack(Stack<Point> source, Stack<Point> dest)
        {

            Stack<Point> aux = new Stack<Point>();
            foreach (Point p in source)
            {
                aux.Push(p);
            }
            foreach (Point p in aux)
            {
                dest.Push(p);
            }

        }

        /// <summary>
        /// Prekopirovanie obsahu stacku do druheho stacku v opačnom poradí
        /// </summary>
        /// <param name="source">Zdroj</param>
        /// <param name="dest">Cieľ</param>
        public static void copyStackToStackReverse(Stack<Point> source, Stack<Point> dest)
        {
            for (int i = 0; i < source.Count(); i++)
            {
                dest.Push(source.ElementAt(i));
            }

        }

        /// <summary>
        /// <para>prekopirovanie prvkov z Listu do Stacku</para>
        /// </summary>
        /// <param name="source">Zdroj, List</param>
        /// <param name="dest">Cieľ, Stack</param>
        public static void copyListToStack(List<Point> source, Stack<Point> dest)
        {
            foreach (Point p in source)
            {
                dest.Push(p);
            }

        }

        /// <summary>
        /// <para>Metoda vymaze bod z zoznamu / List - vymaze sa iba taky bod, ktory ma rovnaku X a Y suradnicu</para>
        /// </summary>
        /// <param name="stack">Stack</param>
        /// <param name="toRemove">Bod na vymazanie - ! pozor objekt :  System.Drawing.Point</param>
        public static void removePointFromList(Stack<Point> stack, Point toRemove)
        {
            Stack<Point> newStack = new Stack<Point>();
            
            for (int i = 0; i < stack.Count; i++)
            {
                if (stack.ElementAt(i).X != toRemove.X || stack.ElementAt(i).Y != toRemove.Y)
                {
                    newStack.Push(stack.ElementAt(i));
                }
            }

            stack.Clear();

            StackHelper.copyStackToStack(newStack, stack);

        }

    }
}
