﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;
using Diplo.GraphObjects;

namespace Diplo.Libs
{
    /// <summary>
    /// Trieda pre čítanie dát z súborov typu XML
    /// </summary>
    class XmlLoader
    {

        /// <summary>
        /// Načíta dáta z XML súboru a vráti insťanciu graf-u
        /// </summary>
        /// <param name="fileToRead">Súbor na načítanie, nemusí obsahovať .xml koncovku, defaultne je XMLFile1</param>
        /// <returns>Graf</returns>
        public static Graph loadFromFile(String fileToRead = "XMLFile1")
        {
            Graph graf = new Graph();

            string text = System.IO.File.ReadAllText(System.IO.Directory.GetCurrentDirectory() + @"\files\" + fileToRead + ".xml");
            XmlReader reader = XmlReader.Create(new StringReader(text));
            while (reader.Read())
            {
                switch (reader.NodeType)
                {
                    case XmlNodeType.Element:
                        if(reader.Name.Equals("vertice"))
                        {
                            graf.addVertex(new Vertex(Convert.ToInt32(reader.GetAttribute(0)), Convert.ToInt32(reader.GetAttribute(1)),
                                Convert.ToInt32(reader.GetAttribute(2)), Convert.ToInt32(reader.GetAttribute(3))));
                        }

                        if (reader.Name.Equals("edge"))
                        {
                            graf.addEdge(Convert.ToInt32(reader.GetAttribute(0)), Convert.ToInt32(reader.GetAttribute(1)));
                        }

                        
                        
                        //writer.WriteStartElement(reader.Name);
                        break;
                    case XmlNodeType.Text:
                        //writer.WriteString(reader.Value);
                        break;
                    case XmlNodeType.XmlDeclaration:
                    case XmlNodeType.ProcessingInstruction:
                        //writer.WriteProcessingInstruction(reader.Name, reader.Value);
                        break;
                    case XmlNodeType.Comment:
                        //writer.WriteComment(reader.Value);
                        break;
                    case XmlNodeType.EndElement:
                        //writer.WriteFullEndElement();
                        break;

                    

                }
            }

            return graf;

        }

    }
}
