﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using Diplo.Libs.Geometry;
using Diplo.Libs.Drawing;
using Diplo.Configs;
using Diplo.Debug;

namespace Diplo.Measurements
{
    class Binary
    {

        private Stack<Point> oldPath = new Stack<Point>();
        private static double evaluationCount = 0;
        private static double evaluationValue = 0;

        private static double OLDevaluationCount = 0;
        private static double OLDevaluationValue = 0;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="g"></param>
        /// <param name="path1">Vysledna - pouzita cesta</param>
        /// <param name="path2">Povodna navrhnuta cesta algoritmom</param>
        /// <param name="mode">Povodna navrhnuta cesta algoritmom</param>
        public static void evaluate(Graphics g, Stack<Point> path1, Stack<Point> path2, int mode)
        {
            if (path1.Count > 0 && path2.Count > 0)
            {
                Binary.init();
                Binary.findMiddle(g, path1, path2, LineSegment.pathLength(path1) / 2, 0);
                Binary.update(mode);
            }

        }

        private static void init()
        {
            Binary.OLDevaluationValue = Binary.evaluationValue;
            Binary.OLDevaluationCount = Binary.evaluationCount;

            Binary.evaluationValue = 0;
            Binary.evaluationCount = 0;
        }

        private static void update(int mode)
        {
            if (mode == 1)
            {
                if (Binary.evaluationValue / Binary.evaluationCount > 0)
                {
                    MeasurementBin.MeasurementBinCountValue++;
                    MeasurementBin.MeasurementBinTogetherValue += Binary.evaluationValue / Binary.evaluationCount;
                    MeasurementBin.MeasurementBinLastValue = Binary.evaluationValue / Binary.evaluationCount;
                    MeasurementBin.MeasurementBinMMAll.Add(Binary.evaluationValue / Binary.evaluationCount);
                    MeasurementBin.MeasurementBinAverageValue = MeasurementBin.MeasurementBinTogetherValue / MeasurementBin.MeasurementBinCountValue;                
                }
            }

            if (mode == 2)
            {
                if (Binary.evaluationValue / Binary.evaluationCount > 0)
                {
                    MeasurementBin.MeasurementBinAlgoCountValue++;
                    MeasurementBin.MeasurementBinAlgoTogetherValue += Binary.evaluationValue / Binary.evaluationCount;
                    MeasurementBin.MeasurementBinAlgoLastValue = Binary.evaluationValue / Binary.evaluationCount;
                    MeasurementBin.MeasurementBinAlgoAll.Add(Binary.evaluationValue / Binary.evaluationCount);
                    MeasurementBin.MeasurementBinAlgoAverageValue = MeasurementBin.MeasurementBinAlgoTogetherValue / MeasurementBin.MeasurementBinAlgoCountValue;

                }
            }
        }

        private static void findMiddle(Graphics g, Stack<Point> newPath, Stack<Point> oldPath, double middleLength, int currentDepth)
        {
            currentDepth++;
            if (currentDepth > Config.maxDepth)
            {
                return;
            }
            Binary.evaluationCount++;

            double tempLength = 0;
            double OldTempLength = 0;
            int afterMiddlePoint = -1;

            for (int i = 1; i < newPath.Count(); i++)
            {

                Point p1 = newPath.ElementAt(i - 1);
                Point p2 = newPath.ElementAt(i);

                double dx = Math.Pow(Math.Abs(p1.X - p2.X), 2);
                double dy = Math.Pow(Math.Abs(p1.Y - p2.Y), 2);
                tempLength += Math.Floor(Math.Sqrt(dx + dy));

                if (tempLength > middleLength)
                {
                    afterMiddlePoint = i;
                    break;
                }

                OldTempLength = tempLength;
            }
            

            if (afterMiddlePoint != -1)
            {
                // =====================
                // najdenie stredneho vrcholu
                Point middlePoint = PointLine.computePointOnLineSegmentInDistance(g, newPath, afterMiddlePoint, middleLength - OldTempLength);
                if (middlePoint == null)
                {
                    return;
                }

                // =====================
                // zmeranie vzdialenosti
                evaluationValue += PointLine.computePointToPathDistance(g, middlePoint, oldPath);

                // ===========================================
                //  rekuriznve volanie - vytvorime dve cesty - od START po MIDDLE a od MIDDLE po FINAL
                Stack<Point> startPath = new Stack<Point>();
                startPath.Push(new Point(middlePoint.X, middlePoint.Y));
                for (int i = afterMiddlePoint - 1; i >= 0; i--)
                {
                    Point p = newPath.ElementAt(i);
                    startPath.Push(new Point(p.X, p.Y));
                }

                Stack<Point> endPath = new Stack<Point>();
                for (int i = newPath.Count() - 1; i >= afterMiddlePoint; i--)
                {
                    Point p = newPath.ElementAt(i);
                    endPath.Push(new Point(p.X, p.Y));
                }
                endPath.Push(new Point(middlePoint.X, middlePoint.Y));

                findMiddle(g, startPath, oldPath, LineSegment.pathLength(startPath) / 2, currentDepth);
                findMiddle(g, endPath, oldPath,  LineSegment.pathLength(endPath) / 2, currentDepth);

            }

        }

        

        

        

        



    }
}