﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Diplo.Configs;
using Diplo.Libs.Geometry;

namespace Diplo.Measurements
{
    /// <summary>
    /// Trieda, ktora porovnava pomer medzi najkratsiou mozno cestou (priamka medzi dvoma bodmi) a skutcnou vzdialenostou
    /// </summary>
    class LengthProportion
    {
        private static double shortest = 0;
        // pre MM - vyslednu cestu
        private static double MMPathLength = 0;
        private static double MMPathLengthNew = 0;
        // pre allgo cestu
        private static double AlgoPathLength = 0;
        private static double AlgoPathLengthNew = 0;

        public static void evaluate(Graphics g, Stack<Point> path, int mode)
        {
            if (path.Count > 0)
            {
                LengthProportion.init();

                LengthProportion.shortest = Math.Round(Math.Sqrt(
                    Math.Pow(Math.Abs(path.First().X - path.Last().X), 2) +
                    Math.Pow(Math.Abs(path.First().Y - path.Last().Y), 2)
                    ));

                if(mode == 1){
                    LengthProportion.MMPathLengthNew = LineSegment.pathLength(path);
                }
                if(mode == 2){
                    LengthProportion.AlgoPathLengthNew = LineSegment.pathLength(path);
                }
                

                LengthProportion.update(mode);
            }
        }

        private static void init()
        {
            LengthProportion.shortest = 0;
        }

        private static void update(int mode)
        {
            if (mode == 1)
            {
                //if (LengthProportion.MMPathLengthNew / LengthProportion.shortest > Config.PathLengthComparerTreshold && LengthProportion.MMPathLengthNew != LengthProportion.MMPathLength)
                //{
                    MeasurementBin.LengthProportionCountValue++;

                    MeasurementBin.LengthProportionMMLastValue = LengthProportion.MMPathLengthNew / LengthProportion.shortest;
                    MeasurementBin.LengthProportionMMTogetherValue += (LengthProportion.MMPathLengthNew / LengthProportion.shortest);
                    MeasurementBin.LengthProportionMMAll.Add(LengthProportion.AlgoPathLengthNew / LengthProportion.shortest * 100);

                    LengthProportion.MMPathLength = LengthProportion.MMPathLengthNew;
                //}
            }

            if (mode == 2)
            {
                //if (LengthProportion.AlgoPathLengthNew / LengthProportion.shortest > Config.PathLengthComparerTreshold && LengthProportion.AlgoPathLengthNew != LengthProportion.AlgoPathLength)
                //{
                    MeasurementBin.LengthProportionAlgoCountValue++;

                    MeasurementBin.LengthProportionAlgoLastValue = LengthProportion.AlgoPathLengthNew / LengthProportion.shortest;
                    MeasurementBin.LengthProportionAlgoTogetherValue += (LengthProportion.AlgoPathLengthNew / LengthProportion.shortest);
                    MeasurementBin.LengthProportionAlgoAll.Add(LengthProportion.AlgoPathLengthNew / LengthProportion.shortest * 100);

                    LengthProportion.AlgoPathLength = LengthProportion.AlgoPathLengthNew;
                //}
            }

            

        }

    }
}
