﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Diplo.Robot.Operations;
using System.Threading;
using Diplo.Configs;
using Diplo.GraphObjects;
using Diplo.Debug;

namespace Diplo.Robot
{
    /// <summary>
    /// Manager automatickych operacii. Obsahuje zoznam operacii, ktore sa maju vykonavat a vie ich periodicky spustat
    /// </summary>
    class OperationManager
    {
        public Graph mGraph;
        
        public List<Operation> operations = new List<Operation>();
        private Form1 mForm1;
        private System.Windows.Forms.Label info;

        /// <summary>
        /// <para>Vytvorí inštanciu managera</para>
        /// </summary>
        /// <param name="Graph"></param>
        /// <param name="mForm1"></param>
        /// <param name="info"></param>
        public OperationManager(Graph Graph, Form1 mForm1, System.Windows.Forms.Label info)
        {
            this.mGraph = Graph;
            this.mForm1 = mForm1;
            this.info = info;
        }

        /// <summary>
        /// <para>Periodicky vykonáva po sebe operácie</para>
        /// </summary>
        public void performAll()
        {
            int i = 1;
            foreach(Operation operation in this.operations){
                Thread.Sleep(Config.robotFrequene);
                MyDebug.print("číslo operácie : " + i + " / " + this.operations.Count);
                this.info.Text = "číslo operácie : " + i + " / " + this.operations.Count;

                operation.performAction(this.mGraph);
         
                this.mForm1.needToRedraw = true;
                this.mForm1.Refresh();
                i++;
            }
        }

    }
}
