﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Diplo.GraphObjects;

namespace Diplo.Robot.Operations
{
    /// <summary>
    /// Typ akcie pre robota - POHYB, simuluje interakciu s grafom - pohyb s vrcholom.
    /// </summary>
    class Move : Operation
    {
        private int vertexPosition;
        private int newX;
        private int newY;

        /// <summary>
        /// <para>Vytvorenie operácie - POHYB, uloží sa index vrcholu s ktorým sa bude hýbať a kám sa presunie.</para>
        /// </summary>
        /// <param name="vertexPosition">Index vrcholu z grafu</param>
        /// <param name="newX">nová X poloha</param>
        /// <param name="newY">nová Y poloha</param>
        public Move(int vertexPosition, int newX, int newY)
        {
            this.vertexPosition = vertexPosition;
            this.newX = newX;
            this.newY = newY;
        }

        /// <summary>
        /// <para>Vykonanie akcie. Zmení sa poloha vrcholu.</para>
        /// </summary>
        /// <param name="mGraph"></param>
        public void performAction(Graph mGraph)
        {
                Vertex v = mGraph.getVerticeByIndex(this.vertexPosition);
                if (v != null)
                {
                    v.pos[0] = newX;
                    v.pos[1] = newY;
                }
        }

    }
}
