﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Diplo.GraphObjects;

namespace Diplo.Robot.Operations
{
    /// <summary>
    /// Typ akcie pre robota - ČAKANIE, simuluje žiadnu interakciu v grafe (prípadne s iným klustrom grafu).
    /// </summary>
    class Wait : Operation
    {
        private Form1 form1;

        /// <summary>
        /// <para>Vytvorenie operácie - ČAKANIE</para>
        /// </summary>
        /// <param name="form1"></param>
        public Wait(Form1 form1)
        {
            this.form1 = form1;
        }

        /// <summary>
        /// <para>Vykonanie akcie. Zavolá akciu pre invalidáciu kresliacej plochy, čím sa aktivuje prekreslenie.</para>
        /// </summary>
        /// <param name="mGraph"></param>
        public void performAction(Graph mGraph)
        {
            this.form1.needToRedraw = true;
            this.form1.Invalidate();
        }

    }
}
