﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Diplo.MentalMap;
using Diplo.Configs;

namespace Diplo.UI.MentalMapModifiers
{
    /// <summary>
    /// Treda, ktorá manipiluje s CONFIG súborom pri nastavovaní parametrov pre prvú mentálnu mapu.
    /// Nastavovanie sa robí z panela nástrojov (časť Visual.UI).
    /// </summary>
    class DiffController
    {
        /// <summary>
        /// <para>vykresli sa "rozdielovy polygon" - aka velka plocha sa zmenila</para>
        /// </summary>
        /// <param name="MaxDiffController"></param>
        /// <param name="mButton"></param>
        public static void drawDiffPolygon(MaxDifMap MaxDiffController, Button mButton)
        {
            if (Config.drawDiffPolygon == true)
            {
                Config.drawDiffPolygon = false;
                mButton.Text = "Zapnut";
            }
            else
            {
                Config.drawDiffPolygon = true;
                mButton.Text = "Vypnut";
            }
        }

        /// <summary>
        /// <para>vykresli sa povodna cesta, ktoru navrhuje kresliaci algoritmus
        /// farba : pink</para>
        /// </summary>
        /// <param name="MaxDiffController"></param>
        /// <param name="mButton"></param>
        public static void drawOriginalPath(MaxDifMap MaxDiffController, Button mButton)
        {
            if (Config.drawAlgoPath == true)
            {
                Config.drawAlgoPath = false;
                mButton.Text = "Zapnut";
            }
            else
            {
                Config.drawAlgoPath = true;
                mButton.Text = "Vypnut";
            }
        }

        /// <summary>
        /// <para>vykresli sa kusok starej cesty, ktora by sa pouzila za normalnych okolnosti
        /// farba : zelena</para>
        /// </summary>
        /// <param name="MaxDiffController"></param>
        /// <param name="mButton"></param>
        public static void drawOldPath(MaxDifMap MaxDiffController, Button mButton)
        {
            if (Config.drawOldPath == true)
            {
                Config.drawOldPath = false;
                mButton.Text = "Zapnut";
            }
            else
            {
                Config.drawOldPath = true;
                mButton.Text = "Vypnut";
            }
        }

        /// <summary>
        /// <para>Zmena max. počtu nových vrcholov.</para>
        /// </summary>
        /// <param name="MaxDiffController"></param>
        /// <param name="mTextBox"></param>
        public static void changeDiffCount(MaxDifMap MaxDiffController, TextBox mTextBox)
        {
            int newValue = 2;
            try
            {
                newValue = Convert.ToInt32(mTextBox.Text);
            }
            catch (FormatException exception)
            {
                Debug.MyDebug.print("! POZOR ! Zadalo sa zle číslo" + exception.Source);
            }
            Config.maxDifferent = newValue;
        }

    }
}
